name: Build & Production
on:
  push:
    tags:
      - 'release-*'

env:
  CONTAINER_REGISTRY: ghcr.io
  CONTAINER_REGISTRY_USER: ${{ secrets.GHCR_CONTAINER_REGISTRY_USER }}
  CONTAINER_REGISTRY_PASSWORD: ${{ secrets.GHCR_TOKEN }}
  CONTAINER_REGISTRY_REPO: ghcr.io/city-of-helsinki/${{ github.event.repository.name }}
  REPO_NAME: ${{ github.event.repository.name }}
  KUBECONFIG_RAW: ${{ secrets.KUBECONFIG_RAW_STABLE }}
  BUILD_ARTIFACT_FOLDER: 'build_artifacts'
  SERVICE_ARTIFACT_FOLDER: 'service_artifacts'
  SERVICE_PORT: '8080'

jobs:
  build:
    runs-on: ubuntu-latest
    name: Build
    steps:
      - uses: actions/checkout@v2
      - name: Build
        uses: andersinno/kolga-build-action@v2

  production:
    runs-on: ubuntu-latest
    needs: build
    name: Production
    steps:
      - uses: actions/checkout@v2
      - uses: andersinno/kolga-setup-action@v2

      - name: Deploy
        uses: andersinno/kolga-deploy-action@v2
        with:
          track: 'stable'
        env:
          K8S_NAMESPACE: ${{ secrets.K8S_NAMESPACE_STABLE }}
          ENVIRONMENT_URL: https://${{ secrets.ENVIRONMENT_URL_STABLE }}
          K8S_SECRET_CRD_URL: ${{ secrets.GH_SECRET_CRD_URL }}
          K8S_SECRET_CRD_TOKEN: ${{ secrets.GH_SECRET_CRD_TOKEN }}
          K8S_SECRET_MAAS_API_KEY_HASH: ${{ secrets.GH_SECRET_MAAS_API_KEY_HASH }}
          K8S_SECRET_DATABASE_HOST: ${{ secrets.K8S_SECRET_DATABASE_HOST_STABLE }}
          K8S_SECRET_DATABASE_URL: ${{ secrets.K8S_SECRET_DATABASE_URL_STABLE }}
          K8S_SECRET_DATABASE_PORT: ${{ secrets.K8S_SECRET_DATABASE_PORT_STABLE }}
          K8S_SECRET_DATABASE_DB: ${{ secrets.K8S_SECRET_DATABASE_DB_STABLE }}
          K8S_SECRET_DATABASE_USERNAME: ${{ secrets.K8S_SECRET_DATABASE_USERNAME_STABLE }}
          K8S_SECRET_DATABASE_PASSWORD: ${{ secrets.K8S_SECRET_DATABASE_PASSWORD_STABLE }}
